Crypto++ 8.0 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Member Functions | List of all members
DL_GroupParameters_IntegerBased Class Referenceabstract

Integer-based GroupParameters specialization. More...

Inheritance diagram for DL_GroupParameters_IntegerBased:

## Public Member Functions
void | Initialize (const DL_GroupParameters_IntegerBased &params)
| Initialize a group parameters over integers. More...
void | Initialize (RandomNumberGenerator &rng, unsigned int pbits)
| Create a group parameters over integers. More...
void | Initialize (const Integer &p, const Integer &g)
| Initialize a group parameters over integers. More...
void | Initialize (const Integer &p, const Integer &q, const Integer &g)
| Initialize a group parameters over integers. More...
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
const Integer & | GetSubgroupOrder () const
| Retrieves the subgroup order. More...
Integer | GetGroupOrder () const
| Retrieves the order of the group. More...
bool | ValidateGroup (RandomNumberGenerator &rng, unsigned int level) const
| Check the group for errors. More...
bool | ValidateElement (unsigned int level, const Integer &element, const DL_FixedBasePrecomputation< Integer > *precomp) const
| Check the element for errors. More...
bool | FastSubgroupCheckAvailable () const
void | EncodeElement (bool reversible, const Element &element, byte *encoded) const
unsigned int | GetEncodedElementSize (bool reversible) const
| Retrieves the encoded element's size. More...
Integer | DecodeElement (const byte *encoded, bool checkForGroupMembership) const
| Decodes the element. More...
Integer | ConvertElementToInteger (const Element &element) const
| Converts an element to an Integer. More...
Integer | GetMaxExponent () const
| Retrieves the maximum exponent for the group. More...
OID | GetAlgorithmID () const
virtual const Integer & | GetModulus () const =0
virtual void | SetModulusAndSubgroupGenerator (const Integer &p, const Integer &g)=0
void | SetSubgroupOrder (const Integer &q)
Public Member Functions inherited from ASN1CryptoMaterial< DL_GroupParameters< Integer > >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Public Member Functions inherited from DL_GroupParameters< Integer >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation. More...
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
virtual const Element & | GetSubgroupGenerator () const
| Retrieves the subgroup generator. More...
virtual void | SetSubgroupGenerator (const Element &base)
| Sets the subgroup generator. More...
virtual Element | ExponentiateBase (const Integer &exponent) const
| Exponentiates the base. More...
virtual Element | ExponentiateElement (const Element &base, const Integer &exponent) const
| Exponentiates an element. More...
virtual const DL_GroupPrecomputation< Element > & | GetGroupPrecomputation () const=0
| Retrieves the group precomputation. More...
virtual const DL_FixedBasePrecomputation< Element > & | GetBasePrecomputation () const=0
| Retrieves the group precomputation. More...
virtual DL_FixedBasePrecomputation< Element > & | AccessBasePrecomputation ()=0
| Retrieves the group precomputation. More...
virtual Integer | GetCofactor () const
| Retrieves the cofactor. More...
virtual void | EncodeElement (bool reversible, const Element &element, byte *encoded) const=0
| Encodes the element. More...
virtual bool | IsIdentity (const Element &element) const=0
| Determines if an element is an identity. More...
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const=0
| Exponentiates a base to multiple exponents. More...
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Static Public Member Functions
static std::string | StaticAlgorithmNamePrefix ()
Static Public Member Functions inherited from NameValuePairs
static void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Additional Inherited Members
Public Types inherited from DL_GroupParameters< Integer >
typedef Integer | Element

## Detailed Description

Integer-based GroupParameters specialization.

Definition at line 34 of file gfpcrypt.h.

## Member Function Documentation

## ◆ Initialize() [1/4]

void DL_GroupParameters_IntegerBased::Initialize | ( | const DL_GroupParameters_IntegerBased & | params | ) |
| inline

Initialize a group parameters over integers.

Parameters

  params | the group parameters

Definition at line 43 of file gfpcrypt.h.

## ◆ Initialize() [2/4]

void DL_GroupParameters_IntegerBased::Initialize | ( | RandomNumberGenerator & | rng,
|  | unsigned int | pbits
| ) |  |
| inline

Create a group parameters over integers.

Parameters

  rng | a RandomNumberGenerator derived class
  pbits | the size of p, in bits

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 52 of file gfpcrypt.h.

## ◆ Initialize() [3/4]

void DL_GroupParameters_IntegerBased::Initialize | ( | const Integer & | p,
|  | const Integer & | g
| ) |  |
| inline

Initialize a group parameters over integers.

Parameters

  p | the modulus
  g | the generator

Definition at line 58 of file gfpcrypt.h.

## ◆ Initialize() [4/4]

void DL_GroupParameters_IntegerBased::Initialize | ( | const Integer & | p,
|  | const Integer & | q,
|  | const Integer & | g
| ) |  |
| inline

Initialize a group parameters over integers.

Parameters

  p | the modulus
  q | the subgroup order
  g | the generator

Definition at line 65 of file gfpcrypt.h.

## ◆ BERDecode()

void DL_GroupParameters_IntegerBased::BERDecode | ( | BufferedTransformation & | bt | ) |
| virtual

Decode this object from a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Basic Encoding Rules (BER)

Implements ASN1Object.

Definition at line 253 of file gfpcrypt.cpp.

## ◆ DEREncode()

void DL_GroupParameters_IntegerBased::DEREncode | ( | BufferedTransformation & | bt | ) | const
| virtual

Encode this object into a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Distinguished Encoding Rules (DER)

Implements ASN1Object.

Definition at line 272 of file gfpcrypt.cpp.

## ◆ GenerateRandom()

void DL_GroupParameters_IntegerBased::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg
| ) |  |
| virtual

parameters: (ModulusSize, SubgroupOrderSize (optional))

Reimplemented from GeneratableCryptoMaterial.

Reimplemented in DL_GroupParameters_DSA.

Definition at line 204 of file gfpcrypt.cpp.

## ◆ GetVoidValue()

bool DL_GroupParameters_IntegerBased::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const
| virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Implements NameValuePairs.

Reimplemented in DL_GroupParameters_LUC, DL_GroupParameters_GFP, DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >, DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >, and DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >.

Definition at line 281 of file gfpcrypt.cpp.

## ◆ AssignFrom()

void DL_GroupParameters_IntegerBased::AssignFrom | ( | const NameValuePairs & | source | ) |
| virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Implements CryptoMaterial.

Reimplemented in DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >, DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >, and DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >.

Definition at line 287 of file gfpcrypt.cpp.

## ◆ GetSubgroupOrder()

const Integer& DL_GroupParameters_IntegerBased::GetSubgroupOrder | ( |  | ) | const
| inline virtual

Retrieves the subgroup order.

Returns
  the order of subgroup generated by the base element

Implements DL_GroupParameters< Integer >.

Definition at line 79 of file gfpcrypt.h.

## ◆ GetGroupOrder()

Integer DL_GroupParameters_IntegerBased::GetGroupOrder | ( |  | ) | const
| inline virtual

Retrieves the order of the group.

Returns
  the order of the group

Either GetGroupOrder() or GetCofactor() must be overridden in a derived class.

Reimplemented from DL_GroupParameters< Integer >.

Definition at line 80 of file gfpcrypt.h.

## ◆ ValidateGroup()

bool DL_GroupParameters_IntegerBased::ValidateGroup | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const
| virtual

Check the group for errors.

Parameters

  rng | RandomNumberGenerator for objects which use randomized testing
  level | level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

ValidateGroup() must be implemented in a derived class.

Implements DL_GroupParameters< Integer >.

Reimplemented in DL_GroupParameters_DSA.

Definition at line 133 of file gfpcrypt.cpp.

## ◆ ValidateElement()

bool DL_GroupParameters_IntegerBased::ValidateElement | ( | unsigned int | level,
|  | const Integer & | element,
|  | const DL_FixedBasePrecomputation< Integer > * | precomp
| ) |  | const
| virtual

Check the element for errors.

Parameters

  level | level of thoroughness
  element | element to check
  precomp | optional pointer to DL_FixedBasePrecomputation

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 performs group membership checks. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

ValidateElement() must be implemented in a derived class.

Implements DL_GroupParameters< Integer >.

Definition at line 157 of file gfpcrypt.cpp.

## ◆ GetEncodedElementSize()

unsigned int DL_GroupParameters_IntegerBased::GetEncodedElementSize | ( | bool | reversible | ) | const
| virtual

Retrieves the encoded element's size.

Parameters

  reversible | flag indicating the encoding format

Returns
  encoded element's size, in bytes

The format of the encoded element varies by the underlyinhg type of the element and the reversible flag. GetEncodedElementSize() must be implemented in a derived class.

See also
  GetEncodedElementSize(), EncodeElement(), DecodeElement()

Implements DL_GroupParameters< Integer >.

Definition at line 238 of file gfpcrypt.cpp.

## ◆ DecodeElement()

Integer DL_GroupParameters_IntegerBased::DecodeElement | ( | const byte * | encoded,
|  | bool | checkForGroupMembership
| ) |  | const
| virtual

Decodes the element.

Parameters

  encoded | byte array with the encoded element
  checkForGroupMembership | flag indicating if the element should be validated

Returns
  Element after decoding

DecodeElement() must be implemented in a derived class.

Precondition
  `COUNTOF(encoded) == GetEncodedElementSize()`

Implements DL_GroupParameters< Integer >.

Definition at line 244 of file gfpcrypt.cpp.

## ◆ ConvertElementToInteger()

Integer DL_GroupParameters_IntegerBased::ConvertElementToInteger | ( | const Element & | element | ) | const
| inline virtual

Converts an element to an Integer.

Parameters

  element | the element to convert to an Integer

Returns
  Element after converting to an Integer

ConvertElementToInteger() must be implemented in a derived class.

Implements DL_GroupParameters< Integer >.

Definition at line 90 of file gfpcrypt.h.

## ◆ GetMaxExponent()

Integer DL_GroupParameters_IntegerBased::GetMaxExponent | ( |  | ) | const
| virtual

Retrieves the maximum exponent for the group.

Returns
  the maximum exponent for the group

Implements DL_GroupParameters< Integer >.

Definition at line 317 of file gfpcrypt.cpp.

The documentation for this class was generated from the following files:

- gfpcrypt.h
- gfpcrypt.cpp